/*-- Function: fstock_mutasi_rekap(_StartDate date, _EndDate date, _WhId varchar, _ItGrpId varchar, _BPId varchar, _Brand varchar, _Model varchar)*/

/*-- DROP FUNCTION fstock_mutasi_rekap(_StartDate date, _EndDate date, _WhId varchar, _ItGrpId varchar, _BPId varchar, _Brand varchar, _Model varchar);*/


CREATE OR REPLACE FUNCTION fstock_mutasi_rekap(
	_StartDate 	DATE, 
	_EndDate 	DATE, 
	_WhId 		VARCHAR, 
	_ItGrpId 	VARCHAR, 
	_BPId 		VARCHAR, 
	_Brand 		VARCHAR, 
	_Model 		VARCHAR,
	_DeptID		VARCHAR,
	_PrjID 		VARCHAR
) RETURNS SETOF tStTr AS
$BODY$
DECLARE
	_retval			tStTr%ROWTYPE;

	_Merek			VARCHAR(50);
	_ItGrpDesc		VARCHAR(50);
	_ItemDesc		VARCHAR(50);

	_StockAwal		VARCHAR;
	_StBeli			VARCHAR;
	_StrJual		VARCHAR;
	_TotalBrg		VARCHAR;

	_StJual			VARCHAR;
	_StrBeli		VARCHAR;
	_StockTmp		VARCHAR;
	_StockOpname		VARCHAR;
	_Selisih		VARCHAR;
	_StockAkhir		VARCHAR;
	_StCanvasKeluar 	VARCHAR;
	_StCanvasMasuk  	VARCHAR;

	_PId			VARCHAR;
	_StTrNo			VARCHAR(15);
	_StockANo		VARCHAR(15);
	_ItemId			VARCHAR(20);
	__WhId			VARCHAR(3);

	_StockAwal1		NUMERIC(15,4);
	_StBeli1		NUMERIC(15,4);
	_totalPRcv1		NUMERIC(15,4);
	_totalDeliD1		NUMERIC(15,4);
	_StrJual1		NUMERIC(15,4);
	_TotalBrg1		NUMERIC(15,4);

	_StJual1		NUMERIC(15,4);
	_StrBeli1		NUMERIC(15,4);
	_StockTmp1		NUMERIC(15,4);
	_StockOpname1		NUMERIC(15,4);
	_Selisih1		NUMERIC(15,4);
	_StCanvasKeluar1 	NUMERIC(15,4);
	_StCanvasMasuk1  	NUMERIC(15,4);

	_TotStockAwal1		NUMERIC(15,4);
	_TotStockTmp1		NUMERIC(15,4);
	_StockAkhir1  		NUMERIC(15,4);

	_Month			INT2;
	_PYear			INT4;
	cItem			REFCURSOR;
	cWh			REFCURSOR;

	_StockMfgM		NUMERIC(15,4);
	_StockMfgP		NUMERIC(15,4);

BEGIN
	_PId:=NULL;
	
	OPEN cItem FOR
		SELECT b.brandname, ig.itgrpname, i.itemdesc, i.itemid
		FROM item i
		LEFT JOIN itgrp ig ON i.itgrpid=ig.itgrpid
		LEFT JOIN brand b ON i.brandid=b.brandid
		LEFT JOIN model m ON i.modelid=m.modelid
		WHERE i.active=true AND i.isstock=true AND (i._xt!=true OR (i.itemid<>'0' AND i.itemid<>'-1'))
		AND (_ItGrpId IS NULL OR i.itgrpid IN (SELECT * FROM fItGrpList(_ItGrpId)))
		AND (_Brand IS NULL OR i.brandid=_Brand)
		AND (_Model IS NULL OR i.modelid=_Model)
		AND (_BPID IS NULL OR i.vendorid=_BPID)
		ORDER BY b.brandname, ig.itgrpname;
	LOOP
		FETCH cItem INTO _Merek, _ItGrpDesc, _ItemDesc, _ItemId;
		EXIT WHEN NOT FOUND;
						
		_StockAwal1:=fStockBal_StartDate(_ItemID, _WhId, _PId, _StartDate);
		_StockAwal:=fqty1desc(_ItemId, _StockAwal1);

		/*--RAISE EXCEPTION '%', _ItemID||','||_WhId||','||_PId||','||_StartDate;*/
						
		SELECT INTO _StBeli1 
			SUM(fQtyZToQty1(purcd.itemid,purcd.qty,purcd.unit))
		FROM purcd JOIN purc ON purc.purcno=purcd.purcno
		WHERE purcd.itemid=_ItemId
		AND purc.purcdate>=fNoTime(CAST(_StartDate AS DATE))
		AND purc.purcdate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR purcd.whid=_WhId)
		AND (_DeptID IS NULL OR purcd.deptid=_DeptID)
		AND (_PrjID IS NULL OR purcd.prjid=_PrjID)
		AND purc.isdraft=FALSE
		GROUP BY purcd.itemid;

		SELECT INTO _totalPRcv1 
			SUM(fQtyZToQty1(d.itemid, d.qty, d.unit)) 
		FROM prcvd d 
		JOIN prcv m ON d.prcvno=m.prcvno
		WHERE d.itemid=_ItemId
		AND m.prcvdate>=fNoTime(CAST(_StartDate AS DATE))
		AND m.prcvdate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR d.whid=_WhId)
		AND (_DeptID IS NULL OR d.deptid=_DeptID)
		AND (_PrjID IS NULL OR d.prjid=_PrjID)
		AND m.isinvoiced=FALSE
		AND m.isdraft=FALSE
		GROUP BY d.itemid;

		_StBeli1:=COALESCE(_StBeli1, 0)+COALESCE(_totalPRcv1, 0);
		_StBeli:=fQty1Desc(_ItemId, _StBeli1);


		SELECT INTO _StrJual1 
			SUM(fQtyZToQty1(sretd.itemid,sretd.qty,sretd.unit)) 
		FROM sret JOIN sretd ON sret.sretno=sretd.sretno
		WHERE sretd.itemid=_ItemId
		AND sret.sretdate>=fNoTime(CAST(_StartDate AS DATE))
		AND sret.sretdate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR sretd.whid=_WhId)
		AND (_DeptID IS NULL OR sretd.deptid=_DeptID)
		AND (_PrjID IS NULL OR sretd.prjid=_PrjID)
		AND sret.isdraft=FALSE
		GROUP BY sretd.itemid;

		_StrJual:=fQty1Desc(_ItemId, COALESCE(_StrJual1, 0));


		SELECT INTO _StCanvasMasuk1 SUM(fQtyZToQty1(sttrd.itemid,sttrd.qty,sttrd.unit))
		FROM sttrd JOIN sttr ON sttr.sttrno=sttrd.sttrno
		WHERE sttrd.itemid=_ItemId
		AND sttr.sttrdate>=fNoTime(CAST(_StartDate AS DATE))
		AND sttr.sttrdate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR whid2=_WhId)
		AND (_DeptID IS NULL OR sttrd.deptid=_DeptID)
		AND (_PrjID IS NULL OR sttrd.prjid=_PrjID)
		AND sttr.isdraft=FALSE
		GROUP BY sttrd.itemid;

		SELECT INTO _StockMfgP SUM(fQtyZToQty1(d.itemid, d.qty, d.unit))
		FROM StockAD d JOIN StockA h ON h.StockANo=d.StockANo
		WHERE h.StockAType in ('MFGP') AND d.ItemID=_ItemId
		AND h.StockADate>=fNoTime(CAST(_StartDate AS DATE))
		AND h.StockADate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR d.whid=_WhId)
		AND (_DeptID IS NULL OR d.deptid=_DeptID)
		AND (_PrjID IS NULL OR d.prjid=_PrjID)
		GROUP BY d.itemid;

		_StCanvasMasuk1:=COALESCE(_StCanvasMasuk1,0)+COALESCE(_StockMfgP,0);

		_StCanvasMasuk:=fqty1desc(_ItemID,COALESCE(_StCanvasMasuk1,0));

		_TotalBrg1:=COALESCE(_StockAwal1,0)+COALESCE(_StBeli1,0)+COALESCE(_StrJual1,0)+COALESCE(_StCanvasMasuk1,0);
		SELECT INTO _TotalBrg * FROM fqty1desc(_ItemId, _TotalBrg1);

		SELECT INTO _StJual1 
			SUM(fQtyZToQty1(saled.itemid,saled.qty,saled.unit)) 
		FROM saled JOIN sale ON sale.saleno=saled.saleno
		WHERE saled.itemid=_ItemId
		AND sale.saledate>=fNoTime(CAST(_StartDate AS DATE))
		AND sale.saledate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR saled.whid=_WhId)
		AND (_DeptID IS NULL OR saled.deptid=_DeptID)
		AND (_PrjID IS NULL OR saled.prjid=_PrjID)
		AND sale.isdraft=FALSE
		GROUP BY saled.itemid;

		SELECT INTO _totalDeliD1 
			SUM(fQtyZToQty1(d.itemid, d.qty, d.unit)-d.qtydret-d.qtydeli) 
		FROM delid d 
		JOIN deli m ON d.delino=m.delino
		WHERE d.itemid=_ItemId
		AND m.delidate>=fNoTime(CAST(_StartDate AS DATE))
		AND m.delidate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR d.whid=_WhId)
		AND (_DeptID IS NULL OR d.deptid=_DeptID)
		AND (_PrjID IS NULL OR d.prjid=_PrjID)
		AND m.isinvoiced=FALSE
		AND m.isdraft=FALSE
		GROUP BY d.itemid;

		_StJual1:=COALESCE(_StJual1, 0)+COALESCE(_totalDeliD1, 0);
		_StJual:=fQty1Desc(_ItemId, _StJual1);

		/*SELECT INTO _StrBeli1, _StrBeli 
			SUM(fQtyZToQty1(cnd.itemid,cnd.qty,cnd.unit)), fqty1desc(cnd.itemid,SUM(fQtyZToQty1(cnd.itemid,cnd.qty,cnd.unit)))
		FROM cnd JOIN cn ON cn.cnno=cnd.cnno
		WHERE cnd.itemid=_ItemId
		AND cn.cndate>=fNoTime(CAST(_StartDate AS DATE))
		AND cn.cndate<=fDate2359(CAST(_EndDate AS DATE))
		GROUP BY cnd.itemid;*/

		SELECT INTO _StrBeli1, _StrBeli 
			SUM(fQtyZToQty1(pretd.itemid,pretd.qty,pretd.unit)), fqty1desc(pretd.itemid,SUM(fQtyZToQty1(pretd.itemid,pretd.qty,pretd.unit)))
		FROM pretd JOIN pret ON pret.pretno=pretd.pretno
		WHERE pretd.itemid=_ItemId
		AND pret.pretdate>=fNoTime(CAST(_StartDate AS DATE))
		AND pret.pretdate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR pretd.whid=_WhId)
		AND (_DeptID IS NULL OR pretd.deptid=_DeptID)
		AND (_PrjID IS NULL OR pretd.prjid=_PrjID)
		AND pret.isdraft=FALSE
		GROUP BY pretd.itemid;

		SELECT INTO _StCanvasKeluar1 SUM(fQtyZToQty1(sttrd.itemid,sttrd.qty,sttrd.unit))
		FROM sttrd JOIN sttr ON sttr.sttrno=sttrd.sttrno
		WHERE sttrd.itemid=_ItemId
		AND sttr.sttrdate>=fNoTime(CAST(_StartDate AS DATE))
		AND sttr.sttrdate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR whid1=_WhId)
		AND (_DeptID IS NULL OR sttrd.deptid=_DeptID)
		AND (_PrjID IS NULL OR sttrd.prjid=_PrjID)
		AND sttr.isdraft=FALSE
		GROUP BY sttrd.itemid;

		SELECT INTO _StockMfgM SUM(fQtyZToQty1(d.itemid, d.qty, d.unit))
		FROM StockAD d JOIN StockA h ON h.StockANo=d.StockANo
		WHERE h.StockAType in ('MFGM') AND d.ItemID=_ItemId
		AND h.StockADate>=fNoTime(CAST(_StartDate AS DATE))
		AND h.StockADate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR d.whid=_WhId)
		AND (_DeptID IS NULL OR d.deptid=_DeptID)
		AND (_PrjID IS NULL OR d.prjid=_PrjID)
		GROUP BY d.itemid;

		_StCanvasKeluar1:=COALESCE(_StCanvasKeluar1,0)-COALESCE(_StockMfgM,0);

		_StCanvasKeluar:=fqty1desc(_ItemID,COALESCE(_StCanvasKeluar1,0));

		_StockTmp1:=COALESCE(_TotalBrg1,0)-COALESCE(_StJual1,0)-COALESCE(_StrBeli1,0)-COALESCE(_StCanvasKeluar1,0);
		_TotStockTmp1:=COALESCE(_StockTmp1, 0);
		_StockTmp:=fqty1desc(_ItemId, _StockTmp1);


		SELECT INTO _StockOpname1 SUM(fQtyZToQty1(d.itemid, d.qty, d.unit))
		FROM StockAD d JOIN StockA h ON h.StockANo=d.StockANo
		WHERE h.StockAType in ('SADJ','BEG','SIN','SOUT') AND d.ItemID=_ItemId
		AND h.StockADate>=fNoTime(CAST(_StartDate AS DATE))
		AND h.StockADate<=fDate2359(CAST(_EndDate AS DATE))
		AND (_WhId IS NULL OR d.whid=_WhId)
		AND (_DeptID IS NULL OR d.deptid=_DeptID)
		AND (_PrjID IS NULL OR d.prjid=_PrjID)
		GROUP BY d.itemid;
		_StockOpname:=fqty1desc(_ItemId, _StockOpname1);

		/*--_Selisih1:=abs(COALESCE(_StockTmp1,0)-COALESCE(_StockOpname1,0));*/
		/*--_Selisih1:=(_TotalBrg1+COALESCE(_StockOpname1,0))-(COALESCE(_StockTmp1,0)+_StockAkhir1);*/

--		_Selisih1:=_TotalBrg1+(COALESCE(_StockOpname1,0));
--		_Selisih1:=_Selisih1 - (_StockAkhir1 + _StJual1+COALESCE(_StrBeli1,0)+COALESCE(_StCanvasKeluar1,0));

		/*--_Selisih1:=_StJual1;*/
		/*--_Selisih1:=_StrBeli1;*/
/** 		IF (_ItemId='BK264.B.HIAS.50X50') THEN
			RAISE EXCEPTION 'totstock %', COALESCE(_TotStockTmp1, 0)||' <> stock op '||_StockOpname1||' <> stock akhir '||_StockAkhir1;
		END IF;
*/

--		SELECT INTO _StockAkhir1 * FROM fStockBal_EndDate(_ItemID, _WhId, _PId, _EndDate);
		_StockAkhir1:=COALESCE(_TotalBrg1,0)-COALESCE(_StJual1,0)-COALESCE(_StrBeli1,0)-COALESCE(_StCanvasKeluar1,0)+COALESCE(_StockOpname1,0);
		_StockAkhir:=fqty1desc(_ItemId, _StockAkhir1);

		/**SELECT INTO _StockAkhir1 qty FROM stock WHERE itemid=_ItemID AND whid=_WhID AND (pid='' OR pid IS NULL);
		_StockAkhir:=fQty1Desc(_ItemID, _StockAkhir1);
		*/


		_Selisih1:=COALESCE(_TotStockTmp1, 0)+_StockOpname1-_StockAkhir1;
		_Selisih:=fqty1desc(_ItemId, _Selisih1);

		_retval.merek:=_Merek;
		_retval.itgrpdesc:=_ItGrpDesc;
		_retval.itemid:=_ItemId;
		_retval.itemdesc:=_ItemDesc;
		_retval.stockawal:=_StockAwal;
		_retval.stpabrik:=_StBeli;
		_retval.strtoko:=_StrJual;
		_retval.totalbrg:=_TotalBrg;
		_retval.stsales:=_StJual;
		_retval.strpabrik:=_StrBeli;
		_retval.stockakhir:=_StockAkhir;/*--_StockTmp;*/
		_retval.stockopname:=_StockOpname;
		_retval.selisih:=_Selisih;
		_retval.canvasmasuk:=_StCanvasMasuk;
		_retval.canvaskeluar:=_StCanvasKeluar;
		RETURN NEXT _retval;
	END LOOP;
	CLOSE cItem;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;

---------------------------------- OVERLOAD tanpa deptid, prjid --------------------------------------------

CREATE OR REPLACE FUNCTION fstock_mutasi_rekap(
	_StartDate 	DATE, 
	_EndDate 	DATE, 
	_WhId 		VARCHAR, 
	_ItGrpId 	VARCHAR, 
	_BPId 		VARCHAR, 
	_Brand 		VARCHAR, 
	_Model 		VARCHAR
) RETURNS SETOF tStTr AS
$BODY$
DECLARE
	_retval		tStTr%ROWTYPE;
	cMutasi			REFCURSOR;
BEGIN
	OPEN cMutasi FOR
		SELECT * FROM fstock_mutasi_rekap(_StartDate, _EndDate, _WhId, _ItGrpId, _BPId, _Brand, _Model, NULL, NULL);
	LOOP
		FETCH cMutasi INTO _retval;
		EXIT WHEN NOT FOUND;

		RETURN NEXT _retval;
	END LOOP;
	CLOSE cMutasi;	
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;

ALTER FUNCTION fstock_mutasi_rekap(_StartDate date, _EndDate date, _WhId varchar, _ItGrpId varchar, _BPId varchar, _Brand varchar, _Model varchar) OWNER TO bits;
ALTER FUNCTION fstock_mutasi_rekap(_StartDate date, _EndDate date, _WhId varchar, _ItGrpId varchar, _BPId varchar, _Brand varchar, _Model varchar, _DeptID varchar, _PrjID varchar) OWNER TO bits;

